Titanium.include('config.js');
Titanium.include('strip_tags.js');  

var sermons_window = Titanium.UI.currentWindow;
var url = google_calendar;

var data;
var i = 0;
var feedTableView;
var feedTitle = '';

var actInd = Titanium.UI.createActivityIndicator({
  bottom:10, 
  height:50,
  width:10,
  style:Titanium.UI.iPhone.ActivityIndicatorStyle.PLAIN
}); // end actInd

actInd.message= 'Loading calendar';
actInd.show();

function displayItems(itemList){
  for (var c=0;c < itemList.length;c++){	

    if(itemList.item(c).getElementsByTagName("gd:recurrence").length != 1.0){ //if not a recurring event (for now so i dont get a nullpointer exception if one exists)
    var title = null;
    var desc = null;
 
    title = itemList.item(c).getElementsByTagName("title").item(0).text;
    desc = itemList.item(c).getElementsByTagName("content").item(0).text;
    desc = strip_tags(desc,"");

    if (calendar_type=="full"){
      var where = itemList.item(c).getElementsByTagName("gd:where").item(0).getAttribute("valueString");

      var startTime = itemList.item(c).getElementsByTagName("gd:when").item(0).getAttribute("startTime");
      var startTimeSplit = startTime.split("T");
      var dateResult = startTimeSplit[0];
      var startTimeResult = startTimeSplit[1];
      var dateResult = dateResult.split("-");
      var dateYear = dateResult[0];
      var dateMonth = dateResult[1];
      dateMonthWord = convertMonthNumberToWord(dateMonth);
      var dateDate = dateResult[2];
      var oneDigitDate = parseFloat(dateDate);

      var endTime = itemList.item(c).getElementsByTagName("gd:when").item(0).getAttribute("endTime");
      var endTimeSplit = endTime.split("T");
      var endDateResult = endTimeSplit[0];
      var endTimeResult = endTimeSplit[1];
      var endDateResult = endDateResult.split("-");
      var endDateYear = endDateResult[0];
      var endDateMonth = endDateResult[1];
      endDateMonthWord = convertMonthNumberToWord(endDateMonth);
      var endDateDate = endDateResult[2];
      var endoneDigitDate = parseFloat(endDateDate);


   
    } // end if calendar_type==full

    if (calendar_type=="basic"){	

      var dateIndex = desc.indexOf("When:");
      if (dateIndex!=-1) {

        var dateString = desc.substring(dateIndex+5, dateIndex+27);
        var dateResult = dateString.split(" ");
        var dateDate = dateResult[2];

        var oneDigitDate = dateDate;
  
        var dateMonth = dateResult[3];
        var dateMonthWord;
       
        convertMonthNumberToWord(dateMonth);

        var dateYear = dateResult[4].substring(0,4); 


      } else { // else dateIndex !=-1
        dateIndex = desc.indexOf("First start:");
        dateString = desc.substring(dateIndex+12, dateIndex+33);
        dateResult = dateString.split("-");
        dateDate = dateResult[2];
        var dateDateIndex = dateDate.indexOf(" ");
        dateDate = dateDate.substring(0,dateDateIndex);
   
        oneDigitDate = dateDate;
  
        dateMonth = dateResult[1];
        dateYear = dateResult[0];


      } // end else dateIndex !=-1

        title = title.replace(/&#39;/g, "'");
        title = title.replace(/\&amp;/g,'&');
	
        desc = strip_tags(desc,"");
        desc = desc.replace("Event Status: confirmed", "");
        desc = desc.replace(/[\r\n]+/g, "\n\n");
        desc = desc.replace(/\&amp;/g,'&');
        desc = desc.replace(/&#39;/g, "");
        desc_i = desc.indexOf("Recurring Event", 0);

        if (desc_i != "-1") {
          var desc_f = desc.indexOf("/n/n", desc_i);
          desc_s = desc.substring(desc_i, desc_f);
          desc = desc.replace(desc_s,"");
        } // end if desc_i!=1

      } // end if basic

      switch (dateDate) {
        case "1":
          dateDate="01";
          dateSuffix="st";
        break;
        case "2":
          dateDate="02";
          dateSuffix="nd";
        break;
	case "3":
	  dateDate="03";
          dateSuffix="rd";
        break;
	case "4":
          dateDate="04";
  	break;
        case "5":
          dateDate="05";
	break;
	case "6":
	  dateDate="06";
	break;
	case "7":
	  dateDate="07";
	break;
	case "8":
	  dateDate="08";
	break;
	case "9":
	  dateDate="09";
	break;
	default:
          dateSuffix="th";
        break;
        } // end switch dateDate


      isoDate = dateYear+dateMonth+dateDate; 

      if (parseInt(currentisoDate)<=parseInt(isoDate)) {
        var row = Ti.UI.createTableViewRow({
          indentionLevel:100,
          layout:'vertical',
          leftImage:'bullet.png',
          height:'auto',
          selectedBackgroundColor: '#CDCDCD',
          backgroundColor:'#FDFDF0'
        }); // end row

        var post_title = Ti.UI.createLabel({
          text: title,
          color: '#000',
          textAlign:'left',
          left:60,
          height:'auto',
          width:'auto',
          top:15,
          font:{fontWeight:'bold',fontSize:20}
        }); // end post_title

       var startDateText = dateMonthWord+" "+oneDigitDate+dateSuffix+", "+dateYear;
       var endDateText = endDateMonthWord+" "+endoneDigitDate+dateSuffix+", "+endDateYear; 

        var post_date = Ti.UI.createLabel({
          text: startDateText,
          color: '#000',
          textAlign:'left',
          left:60,
          height:'auto',
          width:'auto',
          bottom:15,
          font:{fontSize:18}
        }); // end post_date
 	
        row.add(post_title);
        row.add(post_date);
        row.thisTitle = title;
        row.thisDesc = desc;
        row.thisDate = dateDate;
        row.thisMonth = dateMonth;
        row.thisYear = dateYear;
        row.startDateText = startDateText;
        row.endDateText = endDateText;
	row.startTimeResult = startTimeResult;
        row.endTimeResult = endTimeResult;
        row.where = where;
        data[i] = row;

    }// end if currentisoDate<=isoDate
    i++;

  }
} // end for var c=0;c < itemList.length;c++

  feedTableView = Titanium.UI.createTableView({
    separatorColor:'#545454',
    scrollable: false,
    data:data,
    bottom:0,
    top:0
  }); // end feedTableView
	
  Titanium.UI.currentWindow.add(feedTableView);

  feedTableView.addEventListener('click', function(e){
    var event_window = Ti.UI.createWindow({
      url:'event.js',
      color: '#000',
      navBarHidden:true,
      cal_title: e.rowData.thisTitle,
      cal_desc: e.rowData.thisDesc,
      cal_year: e.rowData.thisYear,
      cal_month: e.rowData.thisMonth,
      cal_date: e.rowData.thisDate,
      cal_startTime: e.rowData.startTimeResult,
      cal_endTime: e.rowData.endTimeResult,
      cal_startDateText: e.rowData.startDateText,
      cal_endDateText: e.rowData.endDateText,
      cal_where: e.rowData.where,
      website_url: website_url,
      logo: logo
    }); // end event_window
    Titanium.UI.currentTab.open(event_window);
  });  // end feedtableview eventlistener
}

function loadRSSFeed(url){
  data = [];
  xhr = Titanium.Network.createHTTPClient();
  xhr.onerror = function(e) {
    alert("error! "+e.error);
  }; // end xhr onerror
  xhr.open('GET',url);
  xhr.onload = function() {
    actInd.message = null;
    actInd.hide();	
    var xml = this.responseXML;
    var channel = xml.documentElement.getElementsByTagName("entry");
    feedTitle = channel.item(0).getElementsByTagName("title").item(0).text;
    Titanium.UI.currentWindow.title = feedTitle;
    var itemList = xml.documentElement.getElementsByTagName("entry");
    displayItems(itemList);
  }; // end xhr onload function
  xhr.send();	
} // end loadrssfeed function

loadRSSFeed(url);
