Ti.include('config.js');

var sermons_window=Titanium.UI.currentWindow;
sermons_window.backgroundColor = "#CCC";

var podcast_url = itunes_podcast;

var data;
var i = 0;
var feedTableView;
var feedTitle = '';

var actInd = Titanium.UI.createActivityIndicator({
  bottom:10, 
  height:50,
  width:10,
  style:Titanium.UI.iPhone.ActivityIndicatorStyle.PLAIN
});

actInd.message= 'Loading sermons';
actInd.show();

function displayItems(itemList){
  for (var c=0;c < itemList.length;c++){	
    var title = null;
    var desc = null;
    var mp3_url = null;
    if(itemList.item(c).getElementsByTagName("enclosure")!=null){
      title = itemList.item(c).getElementsByTagName("title").item(0).text;

if(itemList.item(c).getElementsByTagName("itunes:author").length != 1.0){
  var author = "";
} else {
      var author = itemList.item(c).getElementsByTagName("itunes:author").item(0).text;
}
      desc = itemList.item(c).getElementsByTagName("description").item(0).text;
      var pubDate = itemList.item(c).getElementsByTagName("pubDate").item(0).text;
      var pubDateResult = pubDate.split(" ");
      var pubDateDate = pubDateResult[1];
      var pubDateMonth = pubDateResult[2];
      var pubDateYear = pubDateResult[3];

      switch (pubDateDate) {
        case "01":
          pubDateDate = "1";
          pubDateSuffix="st";
        break;
        case "02":
          pubDateDate = "2";
          pubDateSuffix="nd";
        break;
        case "03":
          pubDateDate = "3";
          pubDateSuffix="rd";
        case "04":
          pubDateDate = "4";
          pubDateSuffix="th";
        break;
        case "05":
          pubDateDate = "5";
          pubDateSuffix="th";
        break;
        case "06":
          pubDateDate = "6";
          pubDateSuffix="th";
        case "07":
          pubDateDate = "7";
          pubDateSuffix="th";
        break;
        case "08":
          pubDateDate = "8";
          pubDateSuffix="th";
        break;
        case "09":
          pubDateDate = "9";
          pubDateSuffix="th";
        break;
        default:
          pubDateSuffix="th";
        break;
      }

      switch (pubDateMonth) {
        case "Jan":
          pubDateMonth="January";
        break;
        case "Feb":
          pubDateMonth="February";
        break;
        case "Mar":
          pubDateMonth="March";
        break;
        case "Apr":
          pubDateMonth="April";
        break;
        case "May":
          pubDateMonth="May";
        break;
        case "Jun":
          pubDateMonth="June";
        break;
        case "Jul":
          pubDateMonth="July";
        break;
        case "Aug":
          pubDateMonth="August";
        break;
        case "Sep":
          pubDateMonth="September";
        break;
        case "Oct":
          pubDateMonth="October";
        break;
        case "Nov":
          pubDateMonth="November";
        break;
        case "December":
          pubDateMonth="December";
        break;
      }

      //itunes:image must be at least 600x600 square.
if(itemList.item(c).getElementsByTagName("itunes:image").length != 1.0){
  var sermon_art = "";
} else {
      var sermon_art = itemList.item(c).getElementsByTagName("itunes:image").item(0).getAttribute("href");
}
      if (sermon_art == "") {
        sermon_art = "generic_sermon.png";
      }
      title = title.replace(/\n/gi, " ");			
      desc = desc.replace(/\n/gi, " ");
      mp3_url = itemList.item(c).getElementsByTagName("enclosure").item(0).getAttribute("url");
      var row = Ti.UI.createTableViewRow({indentionLevel:100,height:'auto', selectedBackgroundColor: '#CDCDCD',backgroundColor:'#FDFDF0'}); 

      var leftimageView = Ti.UI.createImageView({
        url:sermon_art,
        width:100,
	left: 10,
	top:10,
	bottom: 10,
        height:100
      });

      var post = Ti.UI.createView({ top:0, bottom:0, left: 70,});
      var post_title = Ti.UI.createLabel({
        text: title+"",
	color: '#000',
	textAlign:'left',
	left:60,
	height:'auto',
	width:'auto',
	top:25,
	font:{fontWeight:'bold',fontSize:20}
      });

      var post_author = Ti.UI.createLabel({
	text: author+" on "+pubDateMonth+" "+pubDateDate+pubDateSuffix+", "+pubDateYear+" ",
	color: '#000',
	textAlign:'left',
	left:60,
	height:'auto',
	width:'auto',
	bottom:25,
	font:{fontSize:18}
      });
			
      row.add(post)
      row.add(leftimageView);
      post.add(post_title);
      post.add(post_author);
      row.thisTitle = title;
      row.thisDate = pubDate;
      row.thisMp3 = mp3_url;
      row.thisDesc = desc;
      row.author = author;
      row.thisDate = pubDateDate;
      row.thisMonth = pubDateMonth;
      row.thisYear = pubDateYear;
      row.thisArt = sermon_art;			
      data[i] = row;
      i++;
    } 
  }
  feedTableView = Titanium.UI.createTableView({
    separatorColor:'#545454',
    scrollable: false,
    data:data,
    bottom:0,
    top:0,
  });
  
  Titanium.UI.currentWindow.add(feedTableView);

  feedTableView.addEventListener('click', function(e){
    var sermon_view = Ti.UI.createWindow({
      url:'sermon.js',
      color: '#000',
      navBarHidden:true,
      from_feed: "true",
      mp3_title: e.rowData.thisTitle,
      mp3_file: e.rowData.thisMp3,
      mp3_author: e.rowData.thisAuthor,
      mp3_date: e.rowData.thisDate,
      mp3_month: e.rowData.thisMonth,
      mp3_year: e.rowData.thisYear,
      mp3_art: e.rowData.thisArt,
    });
  
    Titanium.UI.currentTab.open(sermon_view);

    sermon_view.addEventListener('focus', function(e){
      Titanium.Android.NotificationManager.cancel(0);     
    });

    sermon_view.addEventListener('blur', function(e){
   if(Ti.App.player.playing==true){
        Titanium.Android.NotificationManager.notify(0, playing_notification);     
      }
    });

  });
}

function loadRSSFeed(url){
  data = [];
  xhr = Titanium.Network.createHTTPClient();
  xhr.open('GET',url);
  xhr.onload = function() {
    actInd.message = null;
    actInd.hide();	
    var xml = this.responseXML;
    var channel = xml.documentElement.getElementsByTagName("channel");
    feedTitle = channel.item(0).getElementsByTagName("title").item(0).text;
    Titanium.UI.currentWindow.title = feedTitle;
    var itemList = xml.documentElement.getElementsByTagName("item");
    displayItems(itemList);
  };
  xhr.send();	
}






    var intent = Titanium.Android.createIntent({
      url: 'sermon.js',
      flags: Titanium.Android.FLAG_ACTIVITY_CLEAR_TOP | Titanium.Android.FLAG_ACTIVITY_SINGLE_TOP
    });
 
    var pending = Titanium.Android.createPendingIntent({ 
        activity: Titanium.Android.currentActivity,
        intent: intent,
        type: Titanium.Android.PENDING_INTENT_FOR_ACTIVITY,
        flags: Titanium.Android.FLAG_UPDATE_CURRENT
    });

var playing_notification = Titanium.Android.createNotification({
  icon:0x01080024,
  contentIntent: pending,
  contentTitle:'Life Church',
  contentText: 'Playing Sermon',
  tickerText: 'Playing Sermon',
  when: new Date().getTime(),
  flags: Titanium.Android.FLAG_ONGOING_EVENT | Titanium.Android.FLAG_NO_CLEAR
});


loadRSSFeed(podcast_url);
